%bcond_with perl_Test_NoWarnings_enables_stack_trace

Summary:        Make sure you didn't emit any warnings while testing
Name:           perl-Test-NoWarnings
Version:        1.06
Release:        6%{?dist}
License:        LGPLv2+
URL:            https://metacpan.org/release/Test-NoWarnings
Source0:        https://cpan.metacpan.org/authors/id/H/HA/HAARG/Test-NoWarnings-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  make coreutils
BuildRequires:  perl-generators perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.6
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict) perl(warnings)
# Run-time:
BuildRequires:  perl(Carp) perl(Exporter)
BuildRequires:  perl(Test::Builder) >= 0.86
%if %{with perl_Test_NoWarnings_enables_stack_trace}
# Optional
BuildRequires:  perl(Devel::StackTrace)
%endif

# Tests:
BuildRequires:  perl(Config)
BuildRequires:  perl(Test::More) >= 0.47
BuildRequires:  perl(Test::Tester) >= 0.107
%if %{with perl_Test_NoWarnings_enables_stack_trace}
Suggests:       perl(Devel::StackTrace)
%endif


%description
In general, your tests shouldn't produce warnings. This module causes any
warnings to be captured and stored. It automatically adds an extra test
that will run when your script ends to check that there were no warnings.
If there were any warnings, the test will give a "not ok" and diagnostics of
where, when and what the warning was, including a stack trace of what was
going on when the it occurred.


%prep
%autosetup -n Test-NoWarnings-%{version}

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done


%build
perl Makefile.PL NO_PACKLIST=1 NO_PERLLOCAL=1 INSTALLDIRS=vendor
%{make_build}


%install
%{make_install}
%{_fixperms} %{buildroot}/*


%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test


%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/*
%{_mandir}/man3/*


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.06-6
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.06-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.06-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.06-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.06-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Feb 15 2023 rockerzhu <rockerzhu@tencent.com> - 1.06-1
- Initial build
